package com.vimas.interfaceapplet;

import java.awt.*;
import java.util.*;
import java.awt.event.*;

/**
 * <p>Title: </p>
 * <p>Description: </p>
 * <p>Copyright: Copyright (c) 2004</p>
 * <p>Company: Vimas technologies</p>
 * @author miha
 * @version 1.0
 */

public class DialogFrame extends Frame
{
  Obs obs=new Obs();
  Label message = new Label();
  Panel control = new Panel();
  Button ok=new Button();
  Button cancel=new Button();
  String msg=new String("");
//******************************************************************************
   private class Obs extends Observable
   {
     public void myNotifyObservers(Object o)
     {
     this.setChanged();
     this.notifyObservers(o);
     }
   }
//******************************************************************************
  public DialogFrame(String msg)
  {
    try
    {
      this.msg=msg;
      jbInit();
    }
    catch(Exception ex)
    {
      ex.printStackTrace();
    }
  }
//******************************************************************************
  void jbInit() throws Exception
  {
    message.setAlignment(Label.CENTER);
    message.setLocale(java.util.Locale.getDefault());
    message.setText(msg);
    ok.setLabel("OK");
    ok.addActionListener(new ActionListener()
                         {
                         public void actionPerformed(ActionEvent e)
                         {
                         ok_actionPerformed(e);
                         }
                         });
    cancel.setLabel("Cancel");
    cancel.addActionListener(new ActionListener()
                         {
                         public void actionPerformed(ActionEvent e)
                         {
                           cancel_actionPerformed(e);
                         }
                         }
);
    this.setEnabled(true);
    this.setBackground(SystemColor.control);
//    this.setState(0);
    this.setResizable(false);
    this.setTitle("Message");
    control.add(ok);
    control.add(cancel);
    this.add(message, BorderLayout.CENTER);
    this.add(control, BorderLayout.SOUTH);
    this.addWindowListener(new WindowAdapter()
                           {
                           public void windowClosing(WindowEvent e)
                           {
                           ((com.vimas.interfaceapplet.DialogFrame)e.getWindow()).shutdown();
                           }
                           });
  }
//******************************************************************************
  public void addObserver(Observer observer)
  {
  obs.addObserver(observer);
  }
//******************************************************************************
  void ok_actionPerformed(ActionEvent e)
  {
    obs.myNotifyObservers(new Integer(1));
    this.dispose();
  }
//******************************************************************************
  void cancel_actionPerformed(ActionEvent e)
  {
    obs.myNotifyObservers(new Integer(-1));
    this.dispose();
  }
//******************************************************************************
  public void shutdown()
  {
  obs.myNotifyObservers(new Integer(-1));
  this.dispose();
  }
//******************************************************************************
}
