package com.vimas.interfaceapplet;

import java.awt.*;
//import java.lang.reflect.*;
import java.awt.event.*;
import java.applet.*;
import java.net.*;
//import javax.swing.*;
import com.vimas.interfaceapplet.buttons.*;
//import com.vimas.rpapplet4800.RPApplet;

/**
 * <p>Title: </p>
 * <p>Description: </p>
 * <p>Copyright: Copyright (c) 2004</p>
 * <p>Company: Vimas technologies</p>
 * @author miha
 * @version 1.0
 */
//******************************************************************************
public class InterfaceApplet extends Applet
{
  private boolean isStandalone = false;
  Dispatcher d=null;
  //RPApplet r=null;
  BorderLayout borderLayout1 = new BorderLayout();
  BorderLayout borderLayout2 = new BorderLayout();
  BorderLayout borderLayout3 = new BorderLayout();
  CardLayout cl= new CardLayout();

  Panel audiocontrol = new Panel();
  Panel filePanel = new Panel();

  Panel leftPanel = new Panel();
  Panel rightPanel = new Panel();
  Panel bannerPanel = new Panel();

  Panel headerPanel = new Panel();
  Panel statusPanel = new Panel();

  Panel mainPanel = new Panel();

  Panel cardPanel = new Panel();

  StopButton stop = new StopButton(20);
  PauseButton pause = new PauseButton(20);
  RecordButton record = new RecordButton(20);
  PlayButton play = new PlayButton(20);
  TextButton save = new TextButton("Upload",20);
  TextButton open = new TextButton("Listen",20);
  Component filename;// = new Choice();
  TextField curtime = new TextField();
  TextField postime = new TextField();
  Label label1 = new Label();
  TextField status = new TextField();
  //Banner banner = new Banner("Vimas Web Recorder and Player");
  Banner banner = new Banner(Messages.bannerString);
//  Banner banner = new Banner("VIMAS voice recording/playing applet");
  Label loadingLable = new Label();
  FlowLayout flowLayout1 = new FlowLayout();
  FlowLayout flowLayout2 = new FlowLayout();
  Banner shara = new Banner("shara16.png",22,22);
  //Get a parameter value
  public String getParameter(String key, String def)
  {
    return isStandalone ? System.getProperty(key, def) :
        (getParameter(key) != null ? getParameter(key) : def);
  }
//******************************************************************************
  //Construct the applet
  public InterfaceApplet()
  {

    System.out.println("Adding KEY LISTENER ");

  }
//******************************************************************************
  public String getAppletInfo()
  {
  return "Vimas InterfaceApplet for RPapplet";
  }
//******************************************************************************
  //Initialize the applet
  public void init()
  {
    try
    {
      jbInit();
      d=new Dispatcher(this);
      d.setUserServerFolder(this.getParameter("UserServerFolder",""));
    }
    catch (Exception e)
    {
      e.printStackTrace();
    }
  }
//******************************************************************************
  //Component initialization
  private void jbInit() throws Exception
  {
    this.addKeyListener(new Keys());
    mainPanel.setLayout(borderLayout1);
    stop.addActionListener(new InterfaceApplet_stop_actionAdapter(this));
    pause.addActionListener(new InterfaceApplet_pause_actionAdapter(this));
    pause.setSunkable(true);
    record.addActionListener(new InterfaceApplet_record_actionAdapter(this));
    play.addActionListener(new InterfaceApplet_play_actionAdapter(this));
    save.addActionListener(new InterfaceApplet_save_actionAdapter(this));
    open.addActionListener(new InterfaceApplet_open_actionAdapter(this));

    if(Messages.DiskVersion) save.setLabel("save");
    if(Messages.DiskVersion)open.setLabel("open");


    curtime.setColumns(6);
    curtime.setEditable(false);
    curtime.setEnabled(true);
    curtime.setFont(new java.awt.Font("Dialog", 0, 24));
    curtime.setForeground(Color.black);
    //curtime.setText("00:00:00");
    curtime.setText("");
   // curtime.addKeyListener(new Keys());

    postime.setColumns(8);
    postime.setEditable(false);
    postime.setEnabled(true);
    postime.setFont(new java.awt.Font("Dialog", 0, 12));
    postime.setForeground(Color.black);
    postime.setText("");
   // postime.addKeyListener(new Keys());


    label1.setBackground(SystemColor.control);
    label1.setFont(new java.awt.Font("Dialog", 0, 12));

    if(Messages.DiskVersion)
      {
        label1.setText("Active file");
        filename=new TextField();
        ((TextField)filename).setColumns(12);
        ((TextField)filename).setEditable(false);
        ((TextField)filename).setText("");
      }
    else
      {
        label1.setText("Uploaded files");
        filename=new Choice();
        ((Choice)filename).add("                          ");
        ((Choice)filename).setFont(new java.awt.Font("Dialog", 0, 12));
      }


    //filename.add("                          ");
    //filename.setFont(new java.awt.Font("Dialog", 0, 12));
    //filename.setSize(40,20);

    /*filename.setColumns(11);
    filename.setEditable(false);
    filename.setText("");*/

    status.setColumns(10);
    status.setEditable(false);
    status.setEnabled(true);
    status.setText("");
   // status.addKeyListener(new Keys());

    //banner.setAlignment(Label.LEFT);
    //banner.setForeground(Color.blue);
    //banner.setText(" Vimas Web Recorder and Player");
    banner.addActionListener(new ActionListener()
                             {
                             public void actionPerformed(ActionEvent e)
                             {
                             etn_clicked();
                             }
                             });

    flowLayout1.setAlignment(FlowLayout.LEFT);
    mainPanel.setBackground(SystemColor.control);
    audiocontrol.setLayout(flowLayout2);
    flowLayout2.setAlignment(FlowLayout.LEFT);

    loadingLable.setAlignment(Label.CENTER);
    loadingLable.setFont(new java.awt.Font("Dialog", 3, 20));
    loadingLable.setText("Loading Java applet");

    leftPanel.setLayout(new BorderLayout(0,0));
    leftPanel.add(curtime,BorderLayout.CENTER);
    leftPanel.add(postime,BorderLayout.SOUTH);

    rightPanel.setLayout(new BorderLayout());
    rightPanel.add(filePanel,BorderLayout.NORTH);
    rightPanel.add(audiocontrol,BorderLayout.CENTER);

    headerPanel.setLayout(new BorderLayout(0,0));
    headerPanel.add(leftPanel, BorderLayout.WEST);
    headerPanel.add(rightPanel, BorderLayout.EAST);
    //file panel construction
//    flowLayout1.setHgap(0);
    filePanel.setLayout(flowLayout1);
    filePanel.add(label1, null);
    if(Messages.DiskVersion)filePanel.add(new AllingmentComponent(0,20), null);
    filePanel.add(filename, null);
    //banner panel
    bannerPanel.setLayout(new BorderLayout());
    bannerPanel.add(banner,BorderLayout.CENTER);
    shara.loadImage(this);
    shara.addActionListener(new ActionListener()
                            {
                            public void actionPerformed(ActionEvent e)
                            {
                            bannerPressed();
                            }
                            });
    bannerPanel.add(shara,BorderLayout.EAST);

    //audio control panel construction

    //audiocontrol.add(new AllingmentComponent(5,20), null);
    //audiocontrol.setLayout(new FlowLayout(FlowLayout.LEFT,8,0));
    audiocontrol.add(record, null);
    audiocontrol.add(play, null);
    audiocontrol.add(pause, null);
    audiocontrol.add(stop, null);
    audiocontrol.add(open, null);
    audiocontrol.add(save, null);
    //audiocontrol.add(shara,null);
    //status panel construction
    statusPanel.setLayout(borderLayout2);
    statusPanel.add(new Panel(new FlowLayout()).add(status),  BorderLayout.CENTER);
    statusPanel.add(bannerPanel,  BorderLayout.SOUTH);
    //statusPanel.add(new AllingmentComponent(4,20),  BorderLayout.WEST);
    statusPanel.add(new AllingmentComponent(1,20),  BorderLayout.EAST);
    //

    //adding all stuff to mainPanel
    mainPanel.add(headerPanel,  BorderLayout.CENTER);
    //mainPanel.add(filePanel, BorderLayout.NORTH);
    mainPanel.add(statusPanel, BorderLayout.SOUTH);
    //creating card panel
    cardPanel.setLayout(cl);


    cardPanel.add("load",loadingLable);
    cardPanel.add("main",mainPanel);
    //adding all to applet
    this.setLayout(borderLayout3);
    this.add(cardPanel,BorderLayout.CENTER);
    //3D Simulating
    Color d = this.getBackground().darker();
    Color b = this.getBackground().brighter();

    LineComponent left=new LineComponent(LineComponent.VERTICAL,(int)this.getSize().height,b);
    LineComponent top=new LineComponent(LineComponent.HORIZONTAL,(int)this.getSize().width,b);
    LineComponent bottom=new LineComponent(LineComponent.HORIZONTAL,(int)this.getSize().width,d);
    LineComponent right=new LineComponent(LineComponent.VERTICAL,(int)this.getSize().height,d);

    this.add(left, BorderLayout.WEST);
    this.add(top, BorderLayout.NORTH);
    this.add(bottom, BorderLayout.SOUTH);
    this.add(right, BorderLayout.EAST);

  }
//******************************************************************************
public void setMainPanelAvailable()
{
cl.show(cardPanel,"main");
}
//******************************************************************************
public void addFileName(String fname)
{
  if(((Choice)filename).getItemCount()==1)
  {
    if(((Choice)filename).getItem(0).equals("                          "))
       ((Choice)filename).remove(0);
  }
  ((Choice)filename).add(fname);
}
//******************************************************************************
public String getSelectedFileName()
{
  if(((Choice)filename).getSelectedItem().equals("                          "))return null;
  else return ((Choice)filename).getSelectedItem();
}
//******************************************************************************
  protected void bannerPressed()
  {
    URL u = null;
    try
    {
      u = new URL(Messages.bannerUrl);
    }
    catch (MalformedURLException ex)
    {
    }
//    System.out.println("u="+u);
    this.getAppletContext().showDocument(u,"_blank");
  }
//******************************************************************************
 protected void etn_clicked()
{
 URL u = null;
 try
 {
   u = new URL(Messages.bannerUrl);
 }
 catch (MalformedURLException ex)
 {
 }
 this.getAppletContext().showDocument(u,"_blank");
}
//******************************************************************************

//******************************************************************************
  //Start the applet
  public void start()
  {

  }
//******************************************************************************
 //Stop the applet
  public void stop()
  {
  }
//******************************************************************************

//******************************************************************************
  //Destroy the applet
  public void destroy()
  {
  }
//******************************************************************************
  //Get parameter info
  public String[][] getParameterInfo()
  {
    return null;
  }
//******************************************************************************
  //Main method
  public static void main(String[] args)
  {
    InterfaceApplet applet = new InterfaceApplet();
    applet.isStandalone = true;
    Frame frame;
    frame = new Frame();
    frame.setTitle("Applet Frame");
    frame.add(applet, BorderLayout.CENTER);
    applet.init();
    applet.start();
    frame.setSize(350, 80);
    Dimension d = Toolkit.getDefaultToolkit().getScreenSize();
    frame.setLocation( (d.width - frame.getSize().width) / 2,
                      (d.height - frame.getSize().height) / 2);
    frame.setVisible(true);
  }
//******************************************************************************
  public void setStatus_RP(String num, String s)
  {
    d.setStatus_RP(num,s);
//  System.out.println("setStatus_RP: num="+num+" : "+s);
  }
//******************************************************************************
  public void report_RP(String num, String s)
  {
  d.report_RP(num,s);
  }

//******************************************************************************
  public void setTimer_RP(String s)
  {
//  System.out.println("setTimer_RP: "+s);
    d.setTimer_RP(s);
  }
//******************************************************************************
  public void confirmOpen(String num, String s)
  {
  d.confirmOpen(num,s);
  }
//******************************************************************************
  public void confirmRecord(String num, String s)
  {
  d.confirmRecord(num,s);
  }
//******************************************************************************
  public void setFilename(String s)
  {
    d.setFilename(s);
//  System.out.println("setFilename> "+s);
  }
//******************************************************************************
  public void addName(String s)
  {
    d.addName(s);
  }
//******************************************************************************
  public void setRecordLevel(String s)
  {
  d.setRecordLevel(s);
  }
//******************************************************************************
  void play_actionPerformed(ActionEvent e)
  {
    d.play();
  }
//******************************************************************************
  void record_actionPerformed(ActionEvent e)
  {
    d.record();
  }
//******************************************************************************
  void pause_actionPerformed(ActionEvent e)
  {
    d.pause();
  }
//******************************************************************************
  void stop_actionPerformed(ActionEvent e)
  {
    pause.releaseButton();
    d.stop();
  }
//******************************************************************************
  void open_actionPerformed(ActionEvent e)
  {
    d.open();
  }
//******************************************************************************
  void save_actionPerformed(ActionEvent e)
  {
    d.save();
  }
//******************************************************************************
}
//******************************************************************************
class InterfaceApplet_play_actionAdapter implements java.awt.event.ActionListener {
  InterfaceApplet adaptee;

  InterfaceApplet_play_actionAdapter(InterfaceApplet adaptee) {
    this.adaptee = adaptee;
  }
  public void actionPerformed(ActionEvent e) {
    adaptee.play_actionPerformed(e);
  }
}
//******************************************************************************
class InterfaceApplet_record_actionAdapter implements java.awt.event.ActionListener {
  InterfaceApplet adaptee;

  InterfaceApplet_record_actionAdapter(InterfaceApplet adaptee) {
    this.adaptee = adaptee;
  }
  public void actionPerformed(ActionEvent e) {
    adaptee.record_actionPerformed(e);
  }
}
//******************************************************************************
class InterfaceApplet_pause_actionAdapter implements java.awt.event.ActionListener {
  InterfaceApplet adaptee;

  InterfaceApplet_pause_actionAdapter(InterfaceApplet adaptee) {
    this.adaptee = adaptee;
  }
  public void actionPerformed(ActionEvent e) {
    adaptee.pause_actionPerformed(e);
  }
}
//******************************************************************************
class InterfaceApplet_stop_actionAdapter implements java.awt.event.ActionListener {
  InterfaceApplet adaptee;

  InterfaceApplet_stop_actionAdapter(InterfaceApplet adaptee) {
    this.adaptee = adaptee;
  }
  public void actionPerformed(ActionEvent e) {
    adaptee.stop_actionPerformed(e);
  }
}
//******************************************************************************
class InterfaceApplet_open_actionAdapter implements java.awt.event.ActionListener {
  InterfaceApplet adaptee;

  InterfaceApplet_open_actionAdapter(InterfaceApplet adaptee) {
    this.adaptee = adaptee;
  }
  public void actionPerformed(ActionEvent e) {
    adaptee.open_actionPerformed(e);
  }
}
//******************************************************************************
class InterfaceApplet_save_actionAdapter implements java.awt.event.ActionListener {
  InterfaceApplet adaptee;

  InterfaceApplet_save_actionAdapter(InterfaceApplet adaptee) {
    this.adaptee = adaptee;
  }
  public void actionPerformed(ActionEvent e) {
    adaptee.save_actionPerformed(e);
  }
//******************************************************************************
}
